library tags.html;

import 'dart:async';
import 'dart:html';
import 'dart:svg' show SvgElement;
import 'tags.dart';

part 'src/view/command_binding.dart';
part 'src/view/editable_label.dart';
part 'src/view/toggle_button.dart';
part 'src/view/toggle_open.dart';

const Dom HTML = const _Dom();

class _Dom extends Dom {
  
  const _Dom();
  
  static bool _isRegistered = false;
  
  void registerElements() {
    if (!_isRegistered) {
      _isRegistered = true;
      document.registerElement(CommandBinding.TAG, CommandBinding);
      document.registerElement(EditableLabel.TAG, EditableLabel, 
          extendsTag: 'div');
      document.registerElement(ToggleButton.TAG, ToggleButton, 
          extendsTag: 'button');
      document.registerElement(ToggleOpen.TAG, ToggleOpen);
    }
  }
  
  createElement(String tag, [String typeExtention]) => 
      new Element.tag(tag, typeExtention);
  
  createSvgElement(String tag) => new SvgElement.tag(tag);
}
